.TH snmpa_network_interface_filter 3 "snmp  4.13.5" "Ericsson AB" "ERLANG MODULE DEFINITION"
.SH MODULE
snmpa_network_interface_filter \- Behaviour module for the SNMP agent network-interface filter\&.
.SH DESCRIPTION
.LP
This module defines the behaviour of the agent network interface filter\&. A \fIsnmpa_network_interface_filter\fR compliant module must export the following functions: 
.RS 2
.TP 2
*
accept_recv/2
.TP 2
*
accept_send/2
.TP 2
*
accept_recv_pdu/3
.TP 2
*
accept_send_pdu/2
.RE
.LP
The semantics of them and their exact signatures are explained below\&. 
.LP
The purpose of the network interface filter is to allow for filtering of messages (accept or reject) receive and send\&. This is done on two levels: 
.RS 2
.TP 2
*
The first level is at the UDP entry / exit point, i\&.e\&. immediately after the receipt of the message, before any message processing is done (accept_recv) and immediately before sending the message, after all message processing is done (accept_send)\&.
.TP 2
*
The second level is at the MPD entry / exit point, i\&.e\&. immediately after the basic message processing (accept_recv_pdu) / immediately before the basic message processing (accept_send_pdu)\&.
.RE
.LP
Note that the network interface filter is something which is used by the network interface implementation provided by the application (\fIsnmpa_net_if\fR)\&. The default filter accepts all messages\&.
.LP
A network interface filter can e\&.g\&. be used during testing or for load regulation\&. If the intended use is load regulation, see also req_limit and the function register_notification_filter\&. 

.SH DATA TYPES

.nf
port() = integer() > 0
pdu_type() = \&'get-request\&' | \&'get-next-request\&' | \&'get-response\&' | \&'set-request\&' | trap | \&'get-bulk-request\&' | \&'inform-request\&' | report
    
.fi
.SH EXPORTS
.LP
.B
accept_recv(Ip, Port) -> boolean()
.br
.RS
.TP
Types
Ip = ip_address()
.br
Port = port()
.br
.RE
.RS
.LP
Called at the reception of a message (before \fIany\fR processing has been done)\&.
.LP
For the message to be discarded, the function \fImust\fR return \fIfalse\fR\&. 
.RE
.LP
.B
accept_send(Ip, Port) -> boolean()
.br
.RS
.TP
Types
Ip = ip_address()
.br
Port = port()
.br
.RE
.RS
.LP
Called before the sending of a message (after \fIall\fR processing has been done)\&.
.LP
For the message to be discarded, the function \fImust\fR return \fIfalse\fR\&. 
.RE
.LP
.B
accept_recv_pdu(Ip, Port, PduType) -> boolean()
.br
.RS
.TP
Types
Ip = ip_address()
.br
Port = port()
.br
PduType = pdu_type()
.br
.RE
.RS
.LP
Called after the basic message processing (MPD) has been done, but before the pdu is handed over to the master-agent for primary processing\&.
.LP
For the pdu to be discarded, the function \fImust\fR return \fIfalse\fR\&. 
.RE
.LP
.B
accept_send_pdu(Targets, PduType) -> Reply
.br
.RS
.TP
Types
Targets = targets()
.br
targets() = [target()]
.br
target() = {ip_address(), port()}
.br
PduType = pdu_type() > 0
.br
Reply = boolean() | NewTargets
.br
NewTargets = targets()
.br
.RE
.RS
.LP
Called before the basic message processing (MPD) is done, when a pdu has been received from the master-agent\&.
.LP
For the message to be discarded all together, the function \fImust\fR return \fIfalse\fR\&. 
.LP
Note that it is possible for this function to filter out targets (but \fInot\fR add it\&'s own) by returning an updated \fITargets\fR list (\fINewTargets\fR)\&. 
.RE
